import { Uint8ArrayList } from "uint8arraylist";
export declare abstract class PubSubMessage {
    abstract serialize(): Uint8Array | Uint8ArrayList;
    static deserialize(bytes: Uint8ArrayList | Uint8Array): PubSubData | Subscribe | Unsubscribe | GetSubscribers;
}
export declare const toUint8Array: (arr: Uint8ArrayList | Uint8Array) => Uint8Array;
export declare class PubSubData extends PubSubMessage {
    topics: string[];
    strict: boolean;
    data: Uint8Array;
    constructor(options: {
        topics: string[];
        data: Uint8Array | Uint8ArrayList;
        strict?: boolean;
    });
    _serialized: Uint8ArrayList;
    serialize(): Uint8Array | Uint8ArrayList;
    static deserialize(bytes: Uint8Array | Uint8ArrayList): PubSubData;
}
export declare class Subscription {
    topic: string;
    data?: Uint8Array;
    constructor(topic: string, data?: Uint8Array);
}
export declare class Subscribe extends PubSubMessage {
    subscriptions: Subscription[];
    constructor(options: {
        subscriptions: Subscription[];
    });
    _serialized: Uint8ArrayList;
    serialize(): Uint8Array | Uint8ArrayList;
    static deserialize(bytes: Uint8Array | Uint8ArrayList): Subscribe;
}
export declare class Unsubscription {
    topic: string;
    constructor(topic: string);
}
export declare class Unsubscribe extends PubSubMessage {
    unsubscriptions: Unsubscription[];
    constructor(options: {
        topics: string[];
    });
    _serialized: Uint8ArrayList;
    serialize(): Uint8Array | Uint8ArrayList;
    static deserialize(bytes: Uint8Array | Uint8ArrayList): Unsubscribe;
}
export declare class GetSubscribers extends PubSubMessage {
    topics: string[];
    constructor(options: {
        topics: string[];
    });
    _serialized: Uint8ArrayList;
    serialize(): Uint8Array | Uint8ArrayList;
    static deserialize(bytes: Uint8Array | Uint8ArrayList): GetSubscribers;
}
